#!/usr/bin/perl
#
# pview
#
# vLV^TCPvgRr[[
#
# written by http://d.hatena.ne.jp/ultraist/

use Socket;
use strict;

sub child_killer {

    wait();
    $SIG{'CHLD'} = \&child_killer;
}
$SIG{'CHLD'} = \&chld_killer;

MAIN:{
    
    my $pidfile =  './protoview.pid';


    my $timeout = 256;

    my @allow = qw[
		   127.0.0.1
		   192.168.
		   ];


    $ARGV[0] =~ /^-text$|^-binary$/ || &usage;
    $ARGV[1] =~ /^[\d]+$/ || &usage;
    $ARGV[2] || &usage;
    $ARGV[3] =~ /^[0-9]+/ || &usage;
    $ARGV[4] && &usage;

    open(PID, ">$pidfile")
	|| die "$pidfile: $!\n";
    print PID $$;
    close(PID);


    my $print_mode = $ARGV[0];
    my $port = $ARGV[1];
    my $target_host = $ARGV[2];
    my $target_port = $ARGV[3];

    socket(WAIT, PF_INET, SOCK_STREAM, getprotobyname('tcp'))
	|| die("socket: $!\n");
    setsockopt(WAIT, SOL_SOCKET, SO_REUSEADDR, 1)
	|| die("setsockopt: $!\n");
    bind(WAIT, pack_sockaddr_in($port, INADDR_ANY))
	|| die("bind: $!\n");
    listen(WAIT, SOMAXCONN)
	|| die("listen: $!\n");

    print "listen port $port..\n";

    while(1) {
    
	my $client = accept(CLIENT, WAIT);

	if (fork) {

	    close(CLIENT);
	    close(SERVER);

	} else {


	    my $client_ipaddr = (unpack_sockaddr_in($client))[1];
	    $client_ipaddr = inet_ntoa($client_ipaddr);

	    print "Conection by $client_ipaddr\n";

	    my $flag = 0;
	    $flag = 1;
#	    foreach (@allow) {
#		$flag = 1 if ($client_ipaddr =~ /^$_/);
#	    }

	    if ($flag != 1) {
			syswrite(CLIENT, "Who are you?\x0a", 13);
			close(CLIENT);
			close(SERVER);

			die("Connection closed.\n");

	    }

		socket(SERVER, PF_INET, SOCK_STREAM, getprotobyname('tcp'))
			|| die("socket: $!\n");
			
		my $addr = inet_aton($target_host)
			|| die("$target_host: Unknown Host\n");
			
		connect(SERVER, pack_sockaddr_in($target_port, $addr))
			|| die("connect: $!\n");
	
		select(CLIENT); $| = 1;
		select(SERVER); $| = 1;
		select(STDOUT); $| = 1;

		print "Connecting to $target_host:$target_port\n";

		my $rin = 0;
		vec($rin, fileno(CLIENT), 1) = 1;
	    vec($rin, fileno(SERVER), 1) = 1;
	
	    my($rout, $len, $data);
	    while ((select($rout = $rin, undef, undef, $timeout))[0]) {
			if (vec($rout, fileno(CLIENT), 1)) {
			    $len = sysread(CLIENT, $data, 1);
			    if ($len > 0) {
				if (syswrite(SERVER, $data, $len) != $len) {
					close(CLIENT);
					close(SERVER);

					print "\nprotoview: connection closed.\n";

					exit(0);

				} elsif ($print_mode eq '-text') {
				    print $data;
				} else {
				    printf("%02x ", ord($data));
				}
			    } else {
				close(CLIENT);
				close(SERVER);

				print "\nprotoview: connection closed.\n";

				exit(0);

			    }
			} elsif (vec($rout, fileno(SERVER), 1)) {
			    $len = sysread(SERVER, $data, 1);
			    if ($len > 0) {
					if (syswrite(CLIENT, $data, $len) != $len) {
						close(CLIENT);
						close(SERVER);

						print "\nprotoview: connection closed.\n";

						exit(0);

					} elsif ($print_mode eq '-text') {
					    print $data;

					} else {
					    printf("%02x ", ord($data));
					}
			    } else {
					close(CLIENT);
					close(SERVER);

					print "\nprotoview: connection closed.\n";

					exit(0);

			    }
			}
	    }
	    close(CLIENT);
	    close(SERVER);

	    print "\nprotoview: connection closed.\n";

	    exit(0);
	}
    }
}


sub usage {

    warn "Usage: $0 { -text | -binary } [server port] [hostname] [port]\n\n";

    warn "Example: % ./$0 -text 8888 yahoo.com 80 &\n";
    warn "Example: % w3m http://localhost:8888/\n";
    warn "Example: % fg\n";
    warn "Example: ^C\n";
    die "Example: % w3m ./out/yahoo.com_80.html\n";
}
