/** アイコン		*/
module icon;

private import std.string;
private import std.regexp;
private import std.file;
private import std.path;

private import dwt.all;
private import dwt.internal.win32.os;

///version = OLE_COM;

private Image[char[]] g_icon_table;
private Image[char[]] g_favicon_table;

/**
 * ICONリソース初期化
 * 
 * 
 */
public void initializeIcons(Display display = null)
{
	char[][]icons;
	
	// icondir必須
	icons = listdir("icons", "*.png"); 	// png
	icons ~= listdir("icons", "*.gif"); // gif
	icons ~= listdir("icons", "*.ico"); // ico
	
	foreach (char[] icon; icons) {
		debug(icons) writef("%s,%s", icon, getBaseName(getName(icon)));
		g_icon_table[getBaseName(getName(icon))] = new Image(display, icon);
	}
}

/**
 * ICON取得
 *
 * Imageへの変更は保持される
 */
public Image getIcon(char[] name)
{
	Image image;
	try {
		image = g_icon_table[name];
	} catch (Exception) {
		throw new Exception(name ~ " : not found");
	}
	
	return image;
}

/**
 * コンテンツタイプに対応するICONの取得
 *
 * Imageへの変更は保持される
 */
public Image getContentTypeIcon(char[] ext)
{
	static char[][] s_content_type_icon = 
	[
	// document
		"doc",		"page_word",
		"txt",		"page_text",
		"pdf",		"file_acrobat",
		"ppt",		"page_white_powerpoint",
	
	// image
		"png",		"image",
		"gif",		"image",
		"jpeg",		"image",
		"jpg",		"image",
	
		"swf",		"page_flash",
	
	// video
		"wme",		"film",
		"avi",		"film",
		"mpg",		"film",
		"mpeg",		"film",
		"rm",		"film",
	// iso
		"iso",		"cd",
	
	// music
		"mid",		"ipod",
		"mp3",		"ipod",
		"wav",		"ipod",
	
	// exe
		"exe",		"application_osx_terminal",
		"bat",		"application_osx_terminal",
		"com",		"application_osx_terminal",
	
	// archive
		"zip",		"folder",
		"rar",		"folder",
		"lzh",		"folder",
		"gz",		"folder",
	];
	
	for (int i = 0; i < s_content_type_icon.length; i += 2) {
		if (std.string.icmp(ext, s_content_type_icon[i]) == 0) {
			return getIcon(s_content_type_icon[i + 1]);
		}
	}
	
	return getIcon("page");
}

