private import std.stdio;
private import std.regexp;
private import std.stream;
private import std.string;
private import std.conv;

class ConfigParserException: Exception
{
	this(char[] msg)
	{
		super(msg);
	}
}
class ConfigParser
{
protected:
	alias char[] Section;
	alias char[] Key;
	alias char[] Value;
	
	Value[Key][Section] m_db
	
public:
	this()
	{
		
	}
	
	void parse(char[] file)
	{
		File file = new File(file);
		char[] current_section;
		
		foreach (line; file) {
			char[] data = strip(line);
			if (data.length == 0 || data[0] == '#') {
				continue;
			}
			if (data[0] == '[') {
				if (data.length < 2 || data[data.length-1] != ']') {
					throw new ConfigParserException("format error 1");
				}
				current_section = data[1 .. length -1];
				continue;
			}
			if (current_section.length == 0) {
				throw new ConfigParserException("section error");
			}
			char[][] pair = split(data, ":");
			char[] key = strip(pair[0]);
			char[] value = strip(pair[1]);
			
			if (key.length == 0 || value.length == 0) {
				throw new ConfigParserException("format error 2");
			}
			if (value[0] == '%') {
				if (value.length < 4 || value[1] != '(' || value[value.length-1] != ')') {
					throw new ConfigParserException("format error 3");
				}
				char[] variable = strip(value[2 .. length-1]);
				try {
					value = m_db[current_section][variable];
				} catch (Exception) {
					throw new ConfigParserException(format("variable error: %s", variable));
				}
			}
			Value[Key] param;
			param[key] = value;
			
			m_db[current_section] = param;
		}
	}
	
	char[] getString(char[] section, char[] key)
	{
		return m_db[section][key];
	}
	
	int getInt(char[] section, char[] key)
	{
		return toInt(m_db[section][key]);
	}
}









