module pes.net.http.requestgenerator;

private import pes.net.http.header;
private import pes.net.http.message;

class HTTPRequestGenerator: HTTPMessage
{
protected:
	char[] m_method;
	char[] m_path;
	
public:
	this() {}
	
	this(char[] method, char[] path, HTTPHeader header)
	{
		super(header, null);
		m_method = std.string.toupper(method);
		m_path = path;	// decoded
	}
	
	override char[] toString()
	{
		char[] request = std.string.format("%s %s HTTP/%.1f%s%s",
							m_method, m_path, getHeader.getVersion, CRLF, getHeader.toString);
		
		return request;
	}
	
	void[] generateRequest()
	{
		return (cast(void[])toString()) ~ getBody();
	}
	
	void setMethod(char[] method)
	{
		m_method = method;
	}
	
	void setPath(char[] decoded_path)
	{
		m_path = decoded_path;
	}
	
	char[] getMethod()
	{
		return m_method;
	}
	
	char[] getPath()
	{
		return m_path;
	}
}

