module pes.net.http.status;

// Status.pm,v 1.28 からマクロで作成

public enum HTTPStatusCode: int
{
	UNDEF							=	0,
	CONTINUE						=	100,
	SWITCHING_PROTOCOLS				=	101,
	PROCESSING						=	102,
	OK								=	200,
	CREATED							=	201,
	ACCEPTED						=	202,
	NON_AUTHORITATIVE_INFORMATIO	=	203,
	NO_CONTENT						=	204,
	RESET_CONTENT					=	205,
	PARTIAL_CONTENT					=	206,
	MULTI_STATUS					=	207,
	MULTIPLE_CHOICES				=	300,
	MOVED_PERMANENTLY				=	301,
	FOUND							=	302,
	SEE_OTHER						=	303,
	NOT_MODIFIED					=	304,
	USE_PROXY						=	305,
	TEMPORARY_REDIRECT				=	307,
	BAD_REQUEST						=	400,
	UNAUTHORIZED					=	401,
	PAYMENT_REQUIRED				=	402,
	FORBIDDEN						=	403,
	NOT_FOUND						=	404,
	METHOD_NOT_ALLOWED				=	405,
	NOT_ACCEPTABLE					=	406,
	PROXY_AUTHENTICATION_REQUIRE	=	407,
	REQUEST_TIMEOUT					=	408,
	CONFLICT						=	409,
	GONE							=	410,
	LENGTH_REQUIRED					=	411,
	PRECONDITION_FAILED				=	412,
	REQUEST_ENTITY_TOO_LARGE		=	413,
	REQUEST_URI_TOO_LARGE			=	414,
	UNSUPPORTED_MEDIA_TYPE			=	415,
	REQUEST_RANGE_NOT_SATISFIABL	=	416,
	EXPECTATION_FAILED				=	417,
	UNPROCESSABLE_ENTITY			=	422,
	LOCKED							=	423,
	FAILED_DEPENDENCY				=	424,
	INTERNAL_SERVER_ERROR			=	500,
	NOT_IMPLEMENTED					=	501,
	BAD_GATEWAY						=	502,
	SERVICE_UNAVAILABLE				=	503,
	GATEWAY_TIMEOUT					=	504,
	HTTP_VERSION_NOT_SUPPORTED		=	505,
	INSUFFICIENT_STORAGE      		=	507,
}

public char[] getHTTPStatusMessage(HTTPStatusCode code)
{
	switch (code) {	// cast(int)
	case   0: return "!Undefined!";
	case 100: return "Continue";
	case 101: return "Switching Protocols";
	case 102: return "Processing";
	case 200: return "OK";
	case 201: return "Created";
	case 202: return "Accepted";
	case 203: return "Non-Authoritative Information";
	case 204: return "No Content";
	case 205: return "Reset Content";
	case 206: return "Partial Content";
	case 207: return "Multi-Status";
	case 300: return "Multiple Choices";
	case 301: return "Moved Permanently";
	case 302: return "Found";
	case 303: return "See Other";
	case 304: return "Not Modified";
	case 305: return "Use Proxy";
	case 307: return "Temporary Redirect";
	case 400: return "Bad Request";
	case 401: return "Unauthorized";
	case 402: return "Payment Required";
	case 403: return "Forbidden";
	case 404: return "Not Found";
	case 405: return "Method Not Allowed";
	case 406: return "Not Acceptable";
	case 407: return "Proxy Authentication Required";
	case 408: return "Request Timeout";
	case 409: return "Conflict";
	case 410: return "Gone";
	case 411: return "Length Required";
	case 412: return "Precondition Failed";
	case 413: return "Request Entity Too Large";
	case 414: return "Request-URI Too Large";
	case 415: return "Unsupported Media Type";
	case 416: return "Request Range Not Satisfiable";
	case 417: return "Expectation Failed";
	case 422: return "Unprocessable Entity";
	case 423: return "Locked";
	case 424: return "Failed Dependency";
	case 500: return "Internal Server Error";
	case 501: return "Not Implemented";
	case 502: return "Bad Gateway";
	case 503: return "Service Unavailable";
	case 504: return "Gateway Timeout";
	case 505: return "HTTP Version Not Supported";
	case 507: return "Insufficient Storage";
	default:
		break;
	}
	
	return null;
}
