module pes.net.shingetsu.get;

private import std.socket;
private import pes.net.http.all;

class ShinGETsuIO
{
protected:
	InternetAddress 	m_address;
	HTTPConnection		m_connection;
	
public:
	static uint TIMEOUT = 600;
	
	this(InternetAddress address)
	{
		m_address = address;
		m_connection = new HTTPConnection;
	}
	
	void get(HTTPRequestGenerator get_generator)
	{
		scope(exit) {
			close();
		}
		connect();
		m_connection.io(get_generator);
	}
	
	void setListener(HTTPResponseListener listener)
	{
		m_connection.setListener(listener);
	}
	
	void removeListener()
	{
		m_connection.removeListener();
	}
	
	void connect()
	{
		m_connection.connect(m_address, TIMEOUT);
	}
	
	void close()
	{
		m_connection.close();
	}
}

