/* autolink.js
 * Copyright (C) 2006 Hoven Project.
 */

initFunc[initFunc.length] = function () 
{
	var dds;
	var regex;
	var title;
	var nbsp = new RegExp(/\&nbsp\;/g);
	
	// follow up messages
    dds 	= document.getElementsByTagName('dd');
	regex 	= new RegExp(/\&gt;\&gt;([0-9a-f]+)/g);
	
    for (var i = 0; i < dds.length; ++i) {
    	dds[i].innerHTML = dds[i].innerHTML.replace(regex, 
    							'<a href="shingetsu://' 
    							+ fileName 
    							+ '/cache/$1#r$1" class="innerlink" target="_blank">$&</a>');
    }
    
    // WWW
	regex 	= new RegExp(/(h?ttp\:\/\/[\w\.\-\/\?\#\%\=\&\,\;\:\~]+)/g);
    for (var i = 0; i < dds.length; ++i) {
    	dds[i].innerHTML = dds[i].innerHTML.replace(regex, 
    		function(a) {
    			if (a.charAt(0) == 'h') {
	    			return '<a href="'+ a +'">' + a + '</a>';
	    		} else {
	    			return '<a href="h'+ a +'">' + a + '</a>';
	    		}
    		}
    	);
    }
    
    // wiki style
	regex 	= new RegExp(/\[\[([^\]]+)\][\]]+/g);
	
    for (var i = 0; i < dds.length; ++i) {
	    dds[i].innerHTML = dds[i].innerHTML.replace(regex, 
	    	function (wikiname) {
	    		var title = wikiname.substring(2, wikiname.length -2);
	    		title = title.replace(nbsp, ' ');
	    		var split = title.split("/");
	    		if (split.length == 1) {
		    		return '<a href="shingetsu://' + encodeThreadName(title) + '/get">' + wikiname + '</a>';
		    	}
		    	
		    	var file = encodeThreadName(split[0]);
		    	return '<a href="shingetsu://' + file + '/get/' + split[1] + '">' + wikiname + '</a>';
		    }
	    );
    }
}

function encodeThreadName(title)
{
	var code;
	title = utf16to8(title);
	title = title.replace(/./g, function(s) {
	    c = s.charCodeAt(0);
	    if(c < 256)
			return my_hex(c, 2);
	});
	
	return "thread_" + title;
}


//--------------------------------------------------------------
/* utf.js - UTF-8 <=> UTF-16 convertion
 *
 * Copyright (C) 1999 Masanao Izumo <iz@onicos.co.jp>
 * Version: 1.0
 * LastModified: Dec 25 1999
 * This library is free.  You can redistribute it and/or modify it.
 */

/*
 * Interfaces:
 * utf8 = utf16to8(utf16);
 * utf16 = utf16to8(utf8);
 */

function utf16to8(str) {
    var out, i, len, c;

    out = "";
    len = str.length;
    for(i = 0; i < len; i++) {
	c = str.charCodeAt(i);
	if ((c >= 0x0001) && (c <= 0x007F)) {
	    out += str.charAt(i);
	} else if (c > 0x07FF) {
	    out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
	    out += String.fromCharCode(0x80 | ((c >>  6) & 0x3F));
	    out += String.fromCharCode(0x80 | ((c >>  0) & 0x3F));
	} else {
	    out += String.fromCharCode(0xC0 | ((c >>  6) & 0x1F));
	    out += String.fromCharCode(0x80 | ((c >>  0) & 0x3F));
	}
    }
    return out;
}

function utf8to16(str) {
    var out, i, len, c;
    var char2, char3;

    out = "";
    len = str.length;
    i = 0;
    while(i < len) {
	c = str.charCodeAt(i++);
	switch(c >> 4)
	{ 
	  case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7:
	    // 0xxxxxxx
	    out += str.charAt(i-1);
	    break;
	  case 12: case 13:
	    // 110x xxxx   10xx xxxx
	    char2 = str.charCodeAt(i++);
	    out += String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F));
	    break;
	  case 14:
	    // 1110 xxxx  10xx xxxx  10xx xxxx
	    char2 = str.charCodeAt(i++);
	    char3 = str.charCodeAt(i++);
	    out += String.fromCharCode(((c & 0x0F) << 12) |
					   ((char2 & 0x3F) << 6) |
					   ((char3 & 0x3F) << 0));
	    break;
	}
    }

    return out;
}

function my_hex(n, len) {
    var out, i;
    out = "";
    for(i = 0; i < len; i++) {
	out = "0123456789ABCDEF".charAt(n & 0xf) + out;
	n >>= 4;
    }
    return out;
}
